/*****************************************************************************
*
*       (c) Copyright Kofax Image Products, 1990.  All rights reserved.
*               Unauthorized use, duplication, or distribution is strictly prohibited.
*
******************************************************************************
*
*                File:  kcommon.h
*         Purpose:      Kofax common definitions
*
*       $Revision:   1.12  $
*               $Date:   15 Oct 1992 10:34:42  $
*
*   $NoAuthor:$
*
*      $NoLog:$
*
*****************************************************************************/

#if !defined(kcommon_h)
#define kcommon_h

/****************************************************************************
/*      Data types
*****************************************************************************/

                                                                /* NOTE: OS-specific ifdefs only required */
                                                                /* to avoid redefinitions of same type    */

#if !defined(TRUE)
        #define TRUE            1
        #define FALSE           0
#endif

#if !defined(NULL)
        #define NULL            0
#endif

#if !defined(NULL_HANDLE)
        #define NULL_HANDLE             ((HANDLE) 0)
#endif

#if !defined(FAR)
        #if defined(UNIX)
                #define FAR             /* nil */
                #define NEAR    /* nil */
                #define PASCAL  /* nil */
                #define far             /* nil -- not supposed to be used, but it is */
                #define huge    /* nil */
        #else
                #define FAR             _far
                #define NEAR    _near
                #define PASCAL  _pascal
        #endif
        #define LONG            long
        #define VOID            void
#endif

#if defined(DOS) || defined(OS2) || defined(UNIX)
        #if defined(DOS) || defined(UNIX)
                typedef unsigned char   BYTE;
                typedef int                             BOOL;
        #endif
        typedef unsigned short          WORD;
        typedef unsigned LONG           DWORD;
        typedef WORD                            HANDLE;
        typedef int FAR                         *LPINT;
        typedef char                            *PSTR;
        typedef char NEAR                       *NPSTR;
        typedef char FAR                        *LPSTR;
#endif

typedef short int                       SWORD;
typedef SWORD FAR                       *LPSWORD;

#if defined(DOS) || defined(OS2) || defined(WIN2X) || defined(UNIX)
        typedef BYTE FAR                   *LPBYTE;
        typedef WORD FAR                   *LPWORD;
        typedef DWORD FAR                  *LPDWORD;
        typedef VOID FAR                   *LPVOID;
#endif

/***** Kofax base types, these should be used in lieu of the old-style */
/***** types based on Windows, e.g. WORD. */

#if !defined(KOFAXTYPES)
        #define KOFAXTYPES
        typedef unsigned char           KBYTE;          /* 8-bit unsigned integer */
        typedef unsigned short          KWORD;          /* 16-bit unsigned integer */
        typedef unsigned long           KDWORD;         /* 32-bit unsigned integer */
        typedef short                           KSWORD;         /* 16-bit signed integer */
#endif

typedef char                            KSBYTE;         /* 8-bit signed integer */
typedef long                            KSDWORD;        /* 32-bit signed integer */

typedef KBYTE FAR                       *LPKBYTE;
typedef KWORD FAR                       *LPKWORD;
typedef KDWORD FAR                      *LPKDWORD;
typedef KSBYTE FAR                      *LPKSBYTE;
typedef KSWORD FAR                      *LPKSWORD;
typedef KSDWORD FAR                     *LPKSDWORD;

#ifdef UNIX
        /* temporary, until names are changed in imk/newkse */
        #define SBYTE KSBYTE
#endif

/***** The type used to represent a screen/bitmap coordinate or offset */
/***** So far, this works with all of DOS, WIN, OS/2 and UNIX */

typedef short int               COORD;

/***** Define point and rectangle types for OS/2, DOS, and UNIX */

#if defined(DOS) || defined(OS2) || defined(UNIX)
        typedef struct tagRECT {        
                COORD   left;
                COORD   top;
                COORD   right;
                COORD   bottom;
        } RECT;
        typedef RECT                    *PRECT;
        typedef RECT NEAR               *NPRECT;
        typedef RECT FAR                *LPRECT;

        typedef struct tagPOINT {   
                COORD   x;
                COORD   y;
        } POINT;
        typedef POINT                   *PPOINT;
        typedef POINT NEAR              *NPPOINT;
        typedef POINT FAR               *LPPOINT;
        #if !defined(MAKEPOINT)
                #define MAKEPOINT(l)    (*((POINT *)&(l)))
        #endif
#endif

/****************************************************************************
**      Macros
*****************************************************************************/

#if !defined(min)
        #define min(a,b)                        (((a) <= (b)) ? (a) : (b))
        #define max(a,b)                        (((a) >= (b)) ? (a) : (b))
#endif

#if !defined(abs)
        #define abs(a)                          (((a) < 0) ? (-(a)) : (a))
#endif

#if !defined(LOBYTE)
        #define LOBYTE(w)                       ((BYTE) (w))
#endif

#if defined(WIN2X)      /* Win2x definition causes compiler warning */
        #undef  HIBYTE                          /* Win2x definition causes compiler warning */
#endif
#if !defined(HIBYTE)
        #define HIBYTE(w)                       ((BYTE) (((WORD)(w) >> 8) & 0xff))
#endif

#if !defined(MAKELONG)
        #define MAKELONG(low,high)      ((LONG)(((unsigned short)(low)) |\
                                                                ((unsigned long)((unsigned short)(high))) <<16))
#endif

/****************************************************************************
**      Native byte order
*****************************************************************************/

#if defined(UNIX)
# if defined(AIX) || defined(SUN)
#  define HIGH_ENDIAN
# endif
#endif

#endif /* kcommon_h */
