/*
** kfhdr.h -- Kofax Demo Header V3
*/
/*****************************************************************************
* (c) Copyright Kofax Image Products, 1989.  All rights reserved.            *
*     Unauthorized use, duplication, or distribution is strictly prohibited. *
*****************************************************************************/
/*
 * $Revision:   1.6  $
 *     $Date:   15 Oct 1992 10:34:48  $
 * $NoAuthor:$
 *
 *    $NoLog:$
 */
/*tab=4*/


typedef struct kfhdr
{
    long    kf_magic;           /* header magic number */
    short   kf_hdrsiz;          /* header size */
    short   kf_hdrver;          /* header version # */
    long    kf_imageid;         /* image id # */
    short   kf_width;           /* image width (bytes/scanline) */
    short   kf_length;          /* image length (scanlines) */
    short   kf_format;          /* format code */
    char    kf_bitsex;          /* non-zero if bit sex inverted */
    char    kf_color;           /* non-zero if color inverted */
    short   kf_xres;            /* horizontal dots per inch <VER2> */
    short   kf_yres;            /* vertical dots per inch <VER2>*/
    char    kf_planes;          /* number of plans of information <VER2> */
    char    kf_bitspixel;       /* number of bits for each pixel <VER2> */
    short   kf_papersize;       /* origional paper size <VER2> */
    short   kf_pixelwidth;      /* if kf_width==0, this is width in pixels <VER3> */
    char    kf_bitsexcodes;     /* non-zero if bit sex inverted <VER3> */
    char    kf_colorcodes;      /* non-zero if color inverted <VER3> */
    char    kf_noeol;           /* NO EOL option for CCITT 3&4 compression <VER3> */
    char    reserved0;
    char    reserved1[14];
    long    kf_dcreated;        /* date created */
    long    kf_dmodified;       /* date modified */
    long    kf_daccessed;       /* date accessed */
    char    reserved2[4];
    long    kf_ioffset;         /* index text information offset */
    long    kf_ilen;        
    long    kf_coffset;         /* comment text offset */
    long    kf_clen;
    long    kf_uoffset;         /* user data offset */
    long    kf_ulen;
    long    kf_doffset;         /* image data offset */
    long    kf_dlen;
    char    reserved3[32];
} KFHDR;
typedef KFHDR      *PKFHDR;
typedef KFHDR NEAR *NPKFHDR;
typedef KFHDR FAR  *LPKFHDR;


/*
   IMAGE FORMAT CODES
*/
#define KFH_FMTRAW       0  /* transparent */
#define KFH_FMTG31D      1  /* grp 3 1D (EOLS, byte_bound, RTC) */
#define KFH_FMTG32D      2  /* grp 3 2D (K=4, EOLs, byte-bound, EOP) */
#define KFH_FMTG42D      3  /* grp 4 2D (K=inf, ~EOLs, ~byte-bound, EOP*/
#define KFH_PACKBITS    10
#define KFH_PACKBYTES   11


/*
   PAPER SIZES
*/                          /*   Width   Length     Width     Length   */
#define KFH_LETTER       1  /*  8.500" x 11.000"   215.90cm x 279.40cm */
#define KFH_LEGAL        2  /*  8.500" x 14.000"   215.90cm x 355.60cm */
#define KFH_EXECUTIVE    3  /*  7.250" x 10.500"   184.15cm x 266.70cm */
#define KFH_COM10        4  /*  4.123" x  9.500"   104.73cm x 241.30cm */
#define KFH_MONARC       5  /*  3.873" x  7.500"    98.38cm x 190.50cm */
#define KFH_DL           6  /*  4.330" x  8.660"   109.98cm x 219.96cm */
#define KFH_LEDGER       7  /* 11.000" x 17.000"   279.40cm x 431.80cm */
#define KFH_A0          10
#define KFH_A1          11
#define KFH_A2          12
#define KFH_A3          13
#define KFH_A4          14  /*  8.267" x 11.690"   209.97cm x 296.93cm */
#define KFH_A5          15  /*  5.827" x  8.267"   148.00cm x 209.97cm */
#define KFH_B0          20
#define KFH_B1          21
#define KFH_B2          22
#define KFH_B3          23
#define KFH_B4          24
#define KFH_B5          25  /*  6.927" x 9.840"    175.94cm x 249.94cm */
#define KFH_C5          35  /*  6.377" x 9.013"    161.97cm x 228.94cm */


/*
*/
#define KFH_MAGIC   0x68464B2E  /* File Header Magic Number ".KFh" */
#define KFH_VER1    0x0001      /* first Kofax header version # */
#define KFH_VER2    0x0002      /* Added kf_xres thru kf_papersize */
#define KFH_VER3    0x0003      /* Added kf_colorcodes and kf_bitsexcodes */
