#ifndef __OWLEXAMPL_H__
#define __OWLEXAMPL_H__

#include "owl.h"
#include "filedial.h"
#include "tkofaxw.h"
#include "owlexmp2.h"

class TImageApp : public TApplication {
    public:
	TImageApp(LPSTR name, HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmd, int nCmdShow)
		: TApplication(name, hInstance, hPrevInstance, lpCmd, nCmdShow) {};
	virtual void 	InitMainWindow();
};

_CLASSDEF(TImageFrame)
class TImageFrame : public TMDIFrame
{
    protected:
    public:
	TImageFrame(LPSTR ATitle, LPSTR MenuName);
	virtual void	CMOpenImageDialog(RTMessage)	= [CM_FIRST + IDM_OPENIMAGEDIALOG];
	virtual void	CMOpenImageWindow(RTMessage)	= [CM_FIRST + IDM_OPENIMAGEWINDOW];
};

class TImageWindow : public TWindow
{
    protected:
	PTKofaxDisplay	pKofaxDisplay;

    public:
	TImageWindow(PTWindowsObject AParent, LPSTR ATitle)
			: TWindow(AParent, ATitle) {};
	virtual void	CMDisplayOptions(RTMessage Msg)		= [CM_FIRST + IDM_DISPLAYOPTIONS];
	virtual void	CMScaling(RTMessage Msg)		= [CM_FIRST + IDM_SCALING];
	virtual void	SetupWindow();
	virtual void 	WMSize(RTMessage Msg) 		= [WM_FIRST + WM_SIZE];
};

class TImageDialog : public TDialog
{
    protected:
	PTKofaxDisplay	pKofaxDisplay;

    public:
	TImageDialog(PTWindowsObject AParent, LPSTR ATitle);
	virtual void	ButtonDisplayOptions(RTMessage)	= [ID_FIRST + IDC_DISPLAYOPTIONS];
	virtual void	ButtonScaling(RTMessage)	= [ID_FIRST + IDC_SCALING];
	virtual void	ButtonSelectImage(RTMessage)	= [ID_FIRST + IDC_SELECTIMAGE];
};

#endif // __OWLEXAMPL_H__

