QFWIN     PROGRAM

   MAP
     QFIND
     CREATOR
     INFO
     MODULE('QF3_DAT.OBJ')
       QFDAT(*CSTRING,*CSTRING,*CSTRING,*CSTRING,*CSTRING,*CSTRING,LONG),LONG,PASCAL,RAW
     END
   END

   INCLUDE('Equates.CLW')
   INCLUDE('Keycodes.CLW')
   INCLUDE('Errors.CLW')


APPWIN APPLICATION('QuickFind for Windows Demo'),AT(6,5,238,134),SYSTEM,MAX,RESIZE,ICON('QFWIN.ICO'),STATUS
         TOOLBAR,AT(1,1,237,29)
           BUTTON('&Create'),AT(9,6,41,14),MSG('Create (new) Test File'),USE(?CREATE)
           BUTTON('&QuickFind'),AT(59,6,41,14),MSG('Do Speed Test'),USE(?QuickFind)
           BUTTON('Info'),AT(200,5,20,19),MSG('Info'),USE(?info),ICON(icon:question)
         END
       END

 CODE
 OPEN(APPWIN)
  ACCEPT
    CASE EVENT()
    END
    CASE FIELD()
    OF ?CREATE
      CASE EVENT()
      OF Event:Accepted
        CREATOR
      END
    OF ?QUICKFIND
      CASE EVENT()
      OF Event:Accepted
        QFIND
      END
    OF ?INFO
      CASE EVENT()
      OF Event:Accepted
        INFO
      END
    END
  END


QFIND   PROCEDURE

DEMOFILE         FILE,PRE(DEM),DRIVER('Clarion'),CREATE,RECLAIM
BY_CODE            KEY(+DEM:CODE),DUP,OPT,NOCASE
RECORD             RECORD
CODE                 STRING(4)
NAME                 STRING(15)
NUMBER               STRING(20)
PURCH                STRING(30)
                 . .

ListQue            QUEUE,PRE(Que)
CODE                 STRING(4),auto
NAME                 STRING(15),auto
NUMBER               STRING(20),auto
PURCH                STRING(30),auto
RecordPtr            LONG
                   .

Count              BYTE
ReturnValue        LONG
Done               BYTE(0)
OutOfMem           BYTE(0)
QFFile             CSTRING(65)
QFSearch1          CSTRING(31)
QFSearch2          CSTRING(31)
QFSearch3          CSTRING(31)
QFSearch4          CSTRING(31)
QFMethod           CSTRING(6)
QFStartRecord      LONG
FirstPage          BYTE
NRecs              LONG
INQ                LONG
can                byte


QFWIN  WINDOW('QuickFind'),AT(10,10,279,142),SYSTEM,GRAY,MAX,RESIZE
         LIST,AT(16,11,249,80),FONT('Times New Roman',8,,400),USE(?List),HSCROLL,FORMAT('[20L~Code~][60L~Name~][60L~Number~][60L~Purch~]'),FROM(ListQue)
         CUSTOM('Custom 1'),AT(20,100,240,10),USE(?progress),CLASS('GAUGE.VBX','Gauge')
         STRING('Records Found'),AT(121,116,,),FONT('Times New Roman',8,,400),USE(?String1),CENTER
         BOX,AT(16,98,250,14),USE(?Box1),ROUND,COLOR(00H)
         BUTTON(' Next &Item '),AT(16,120,37,14),USE(?Item)
         BUTTON('  E&xit  '),AT(228,120,,),USE(?Exit)
         ENTRY(@s20),AT(120,124,37,10),USE(INQ),SKIP
       END

SPWIN  WINDOW('Search Parameters'),AT(10,10,183,168),GRAY
         ENTRY(@s20),AT(80,10,,),USE(QFSearch1),UPR
         PROMPT('&Record Contains'),AT(5,10,,),USE(?Prompt1)
         PROMPT('And &Record Contains'),AT(5,30,,),USE(?Prompt2)
         ENTRY(@s20),AT(80,30,,),USE(QFSearch2),UPR
         ENTRY(@s20),AT(80,50,,),USE(QFSearch3),UPR
         PROMPT('And &Record Contains'),AT(5,51,72,10),USE(?Prompt3)
         PROMPT('And &Record Contains'),AT(5,70,,),USE(?Prompt4)
         ENTRY(@s20),AT(80,70,,),USE(QFSearch4),UPR
         STRING('For the first time try an ''E'' so you can have a look at the contents of'),AT(5,95,170,10),FONT('Times New Roman',8,,400),USE(?String2)
         STRING('your DemoFile.'),AT(5,105,,),FONT('Times New Roman',8,,400),USE(?String3)
         STRING('Then try the contents of the last record that you entered while creating'),AT(5,115,170,9),FONT('Times New Roman',8,,400),USE(?String4)
         STRING('your DemoFile. This way you can check the speed of QuickFind.'),AT(5,125,,),FONT('Times New Roman',8,,400),USE(?String5)
         BUTTON('&OK'),AT(22,146,,),USE(?OK)
         BUTTON('&Cancel'),AT(120,145,,),USE(?Cancel)
       END


  CODE
  OPEN(QFWIN)
  CLOSE(DEMOFILE)
  Open(DEMOFILE)
  IF ERROR()
    I# = MESSAGE('You have to create a DemoFile first (Choose Create)',,icon:exclamation)
    return
  .
  open(SPWIN)
  can = 0
  ACCEPT
    CASE FIELD()
    OF ?OK
      CASE EVENT()
      OF Event:Accepted
        if QFSEARCH1 = ''
          I# = message('You must enter at least one Search parameter',,icon:exclamation)
          select(?qfsearch1)
          cycle
        .
        break
      END
    OF ?Cancel
      CASE EVENT()
      OF Event:Accepted
        can = 1
        break
      END
    END
  END
  close(SPWIN)
  if can then return.

         IF QFSEARCH2 = '' THEN QFSEARCH2 = QFSEARCH1.
         IF QFSEARCH3 = '' THEN QFSEARCH3 = QFSEARCH1.
         IF QFSEARCH4 = '' THEN QFSEARCH4 = QFSEARCH1.
         NRecs = records(DEMOFILE)
         QFFile = 'DEMOFILE.DAT'
         QFMethod = 'All'
         QFStartRecord =            0
         Count = 9
         FirstPage = 1
         LOOP
           ReturnValue = QFDAT(QFFile,QFSearch1,QFSearch2,|
                                      QFSearch3,QFSearch4,|
                                      QFMethod,QFStartRecord)
           QFStartRecord = ReturnValue
           ?PROGRESS{'VALUE'} = (POINTER(DEMOFILE)/NRecs) * 100
           IF ReturnValue = 0
             Done = 1
             BREAK
           ELSE
             GET(DEMOFILE,ReturnValue)
             IF ERRORCODE() THEN CYCLE.
           .
           Que:code = FORMAT(DEM:CODE)
           Que:name = FORMAT(DEM:NAME)
           Que:number = FORMAT(DEM:NUMBER)
           Que:purch = FORMAT(DEM:PURCH)
           Que:RecordPtr = POINTER(DEMOFILE)
           ADD(ListQue)
           INQ = RECORDS(ListQue)
           IF INQ = Count
             Display(?list)
             break
           .
         .
         select(?List,INQ)
         DISPLAY
         accept
           IF Done = 1
             DISABLE(?Item)
             ?PROGRESS{'VALUE'} = 100
           .
           CASE ACCEPTED()
             
           OF ?Item
             ReturnValue = QFDAT(QFFile,QFSearch1,QFSearch2,|
                                        QFSearch3,QFSearch4,|
                                        QFMethod,QFStartRecord)
             ?PROGRESS{'VALUE'} = (POINTER(DEMOFILE)/NRecs) * 100
             QFStartRecord = ReturnValue
             IF ReturnValue = 0
               Done = 1
               Cycle
             ELSE
               GET(DEMOFILE,ReturnValue)
             .
             Que:code = FORMAT(DEM:CODE)
             Que:name = FORMAT(DEM:NAME)
             Que:number = FORMAT(DEM:NUMBER)
             Que:purch = FORMAT(DEM:PURCH)
             Que:RecordPtr = POINTER(DEMOFILE)
             ADD(ListQue)
             INQ = RECORDS(ListQue)
             DISPLAY()
             SELECT(?List,INQ)
           OF ?Exit
             BREAK
         . .
         FREE(ListQue)
         RETURN

CREATOR     PROCEDURE

Number_Records  LONG
Last_Record     string(30)

CREWIN WINDOW('Creating DemoFile'),AT(10,33,187,141),GRAY
         PROMPT('&Number of Records'),AT(8,5,,),USE(?Prompt1)
         ENTRY(@n_9),AT(94,6,,),USE(Number_Records),REQ
         STRING('Try 500 for starters'),AT(94,20,,),FONT('Times New Roman',8,,400),USE(?String1)
         PROMPT('&Contents of Last Record'),AT(6,37,,),USE(?Prompt2)
         ENTRY(@s30),AT(94,38,85,12),USE(Last_Record)
         STRING('For testing the speed of QuickFind'),AT(94,53,80,9),FONT('Times New Roman',8,,400),USE(?String2)
         BOX,AT(5,80,177,20),USE(?Box1),ROUND
         BUTTON('&Build'),AT(7,119,,),USE(?Build)
         BUTTON('&Exit'),AT(152,119,,),USE(?Exit)
         CUSTOM('Custom 1'),AT(12,85,165,10),USE(?Progress),CLASS('GAUGE.VBX','Gauge')
       END

DEMOFILE         FILE,PRE(DEM),DRIVER('Clarion'),CREATE,RECLAIM
BY_CODE            KEY(+DEM:CODE),DUP,OPT,NOCASE
RECORD             RECORD
CODE                 STRING(4)
NAME                 STRING(15)
NUMBER               STRING(20)
PURCH                STRING(30)
                 . .

 code
  OPEN(CREWIN)
    ACCEPT
    CASE FIELD()
    OF ?BUILD
    IF EVENT() = EVENT:ACCEPTED
               IF Number_Records < 100
                 I# = MESSAGE('Try at least 100 records!')
                 SELECT(?NUMBER_RECORDS)
                 CYCLE
               .
               IF Last_Record = ''
                 I# = MESSAGE('Enter a string for the last record please.',,icon:exclamation)
                 SELECT(?LAST_RECORD)
                 CYCLE
               .
               DISABLE(?BUILD)
               DISABLE(?EXIT)
               CLOSE(DEMOFILE)
               CREATE(DEMOFILE)
               OPEN(DEMOFILE)
               START# = Number_Records
               LOOP Number_Records TIMES
                START# -= 1
                I# = RANDOM(1,17)
                EXECUTE I#
                     DEM:NAME = 'B'
                     DEM:NAME = 'C'
                     DEM:NAME = 'D'
                     DEM:NAME = 'F'
                     DEM:NAME = 'G'
                     DEM:NAME = 'H'
                     DEM:NAME = 'J'
                     DEM:NAME = 'K'
                     DEM:NAME = 'L'
                     DEM:NAME = 'M'
                     DEM:NAME = 'N'
                     DEM:NAME = 'P'
                     DEM:NAME = 'R'
                     DEM:NAME = 'S'
                     DEM:NAME = 'T'
                     DEM:NAME = 'V'
                     DEM:NAME = 'W'
                .
                I# = RANDOM(1,5)
                EXECUTE I#
                     DEM:NAME = CLIP(DEM:NAME) & 'ABA'
                     DEM:NAME = CLIP(DEM:NAME) & 'OCE'
                     DEM:NAME = CLIP(DEM:NAME) & 'IDO'
                     DEM:NAME = CLIP(DEM:NAME) & 'UFI'
                     DEM:NAME = CLIP(DEM:NAME) & 'EGU'
                .
                I# = RANDOM(1,7)
                EXECUTE I#
                     DEM:NAME = CLIP(DEM:NAME) & 'SHIP'
                     DEM:NAME = CLIP(DEM:NAME) & 'SHAQ'
                     DEM:NAME = CLIP(DEM:NAME) & 'AKAR'
                     DEM:NAME = CLIP(DEM:NAME) & 'OMAS'
                     DEM:NAME = CLIP(DEM:NAME) & 'SUCT'
                     DEM:NAME = CLIP(DEM:NAME) & 'LOUW'
                     DEM:NAME = CLIP(DEM:NAME) & 'PIRX'
                .
                I# = RANDOM(1,7)
                EXECUTE I#
                     DEM:NAME = CLIP(DEM:NAME) & 'A  '
                     DEM:NAME = CLIP(DEM:NAME) & 'OH '
                     DEM:NAME = CLIP(DEM:NAME) & 'AKOM'
                     DEM:NAME = CLIP(DEM:NAME) & 'OMALT'
                     DEM:NAME = CLIP(DEM:NAME) & 'IF '
                     DEM:NAME = CLIP(DEM:NAME) & 'EWANGO'
                     DEM:NAME = CLIP(DEM:NAME) & '   '
                .
                DEM:CODE = SUB(DEM:NAME,1,4)
                DEM:NUMBER = RANDOM(1000,9999)
                DEM:NUMBER = CLIP(DEM:NUMBER) & '-'
                DEM:NUMBER = CLIP(DEM:NUMBER) & RANDOM(1000,9999)
                DEM:NUMBER = CLIP(DEM:NUMBER) & '-'
                DEM:NUMBER = CLIP(DEM:NUMBER) & RANDOM(1000,9999)
                DEM:NUMBER = CLIP(DEM:NUMBER) & '-'
                DEM:NUMBER = CLIP(DEM:NUMBER) & RANDOM(1000,9999)
       
                I# = RANDOM(1,8)
                EXECUTE I#
                     DEM:PURCH = 'UPGRADABLE DOT MATRIX MONITOR'
                     DEM:PURCH = 'MODULAR HARD DRIVE CONNECTION'
                     DEM:PURCH = 'REMOTE PRINTING KEYBOARDPLUG'
                     DEM:PURCH = 'COMMUNICATION SOURCEWINDOW KIT'
                     DEM:PURCH = 'MULTI-USER MOUSE-BUTTON'
                     DEM:PURCH = 'COMPATIBLE FOOT HELD SCANNER'
                     DEM:PURCH = 'PROFESSIONAL TECHNOLOGICAL BLA'
                     DEM:PURCH = 'REMOVABLE RESET BUTTON TOOL'
                .
                IF (START#=0) THEN DEM:PURCH=Last_Record.
                APPEND(DEMOFILE)
                ?progress{'value'} = ((Number_Records - START#) / Number_Records) * 100
               .
               BUILD(DEMOFILE)
               CLOSE(DEMOFILE)
               I# = MESSAGE('You now created a random DemoFile with ' & Number_Records & ' records')
               ENABLE(?EXIT)
    .

    OF ?EXIT
    IF EVENT() = EVENT:ACCEPTED
       RETURN
    . . .

INFO        PROCEDURE

INFOTXT     STRING(300)

INFWIN WINDOW('Info'),AT(24,13,220,117),GRAY,DOUBLE
         TEXT,AT(10,10,200,65),USE(infotxt),SKIP,READONLY
         STRING('Majodi Ploegmakers, Princen Information Technology '),AT(10,95,,),FONT('Times New Roman',10,,700),USE(?String1)
         BUTTON('OK'),AT(175,95,35,14),USE(?Ok),DEFAULT
       END

 CODE
 INFOTXT =                 'This simple demo shows how easy it is to integrate'
 INFOTXT = CLIP(INFOTXT) & ' the QuickFind text retrieval kit with Clarion for'
 INFOTXT = CLIP(INFOTXT) & ' Windows. It uses a gauge VBX and QuickFind. First'
 INFOTXT = CLIP(INFOTXT) & ' create a random file with Create then choose Quick'
 INFOTXT = CLIP(INFOTXT) & 'Find to do some searching. See Read.me for more info.'
 INFOTXT = CLIP(INFOTXT) & ' Have fun!!!'
 OPEN(INFWIN)
  ACCEPT
    CASE FIELD()
    OF ?OK
      CASE EVENT()
      OF Event:Accepted
        RETURN
      END
    END
  END
