Option Explicit
Dim r%

Sub AddDeclaration (modtext$, prefix$, dec$)
'adds the new declaration 'dec$' to modtext$(the modules' declarations)
Dim Csection&, Tsection&, Fsection&
Dim insertpoint%
Dim lefts$, rights$
Dim dectype%
Dim p1%, p2%, p3%, lin$
'
On Error GoTo adddecerr
'it's possible for the user to inadvertently attempt
'to paste a dec which is already there. You could scan
'here:
'if instr(modtext$,dec$) then
    'If MsgBox("Declaration already exists! Proceed anyway?",36) <> 6 Then Exit Function
'end if

'find or establish a standard place to put the declaration
Csection = InStr(modtext$, "'***Global Constants***" & nl$)
Tsection = InStr(modtext$, "'***Types***" & nl$)
Fsection = InStr(modtext$, "'***Functions***" & nl$)
'
'create a section if it doesn't exist
If Csection = 0 Then
    modtext$ = modtext$ & nl & "'***Global Constants***" & nl$
    Csection = InStr(modtext$, "'***Global Constants***" & nl$)
End If
If Tsection = 0 Then
    modtext$ = modtext$ & nl$ & "'***Types***" & nl$
    Tsection = InStr(modtext$, "'***Types***" & nl$)
End If
If Fsection = 0 Then
    modtext$ = modtext$ & nl$ & "'***Functions***" & nl$
    Fsection = InStr(modtext$, "'***Functions***" & nl$)
End If

Csection = Csection + 25
Tsection = Tsection + 14
Fsection = Fsection + 18

'determine start of section we are pasting into
Select Case Left$(prefix, 1)
Case "G"'constants
    insertpoint% = Csection
Case "T"'types
    insertpoint% = Tsection
Case "D"'subs/functions
    insertpoint% = Fsection
End Select
'
If insertpoint = 0 Then insertpoint = 1
'split the text
rights$ = Mid$(modtext$, insertpoint%)

'knock yourself out here. I'm just going to add the
'new dec in front of the first line which it preceeds
'in alphabetical order. You could sort the whole section.
'
'skip types
If Left$(prefix, 1) <> "T" Then
If insertpoint < Len(modtext) Then
p1% = 1
Do
    Debug.Print p1
    p2% = InStr(p1%, rights$, nl$) + 2
    Debug.Print p2
    If p2% > p1% Then
	lin$ = Mid$(rights$, p1%, p2% - p1% - 1)
	Debug.Print Len(lin), lin$
	'
	'end of section?
	If InStr(lin$, "'***") Then Exit Do
	'
	If StrComp(dec$, lin$, 1) = -1 Then
	    'the new dec precedes this line
	    Exit Do
	End If
	p1% = p2%
    Else
	Exit Do
    End If
Loop
End If
End If
'
'
lefts$ = Left$(modtext$, insertpoint% - 1 + p1% - 1)'+ p1% - 1)
rights$ = Mid$(modtext$, insertpoint% + p1 - 1)'+ p1%)
modtext$ = lefts$ & dec$ & rights$
'Debug.Print "text modified"
Debug.Print modtext$

Exit Sub

adddecerr:
MsgBox "Err: " & Err & nl & Error(Err), , "PARSE ERROR"
Exit Sub
End Sub

Sub PasteAuto ()
Dim target$, hWnd%
Dim r%, res&, I%, s$
Dim htxt1%, htxt2%, hCmb1%, hCmb2%, hPane%, hCod%
Dim txt As String * 32
'
On Error GoTo autoerr
'try to slam it into a code window
    target$ = UCase(dec.dest)

    'get handle to code window
    hCod% = FindWindow%("OEBDebug", target$)

    'get handle to the pane
    hWnd% = GetWindow%(hCod%, GW_CHILD)
    s$ = Left$(txt$, GetClassName(hWnd%, txt$, Len(txt$)))
    If s$ = "CPaneClass" Then
	hPane% = hWnd%
    Else
	Do While hWnd% <> 0
	    hWnd% = GetWindow%(hWnd%, GW_HWNDNEXT)
	    s$ = Left$(txt, GetClassName(hWnd%, txt, Len(txt)))
	    If s$ = "CPaneClass" Then hPane% = hWnd%
	Loop
    End If

    'get handle to comboboxes
    hCmb1% = GetWindow%(hPane%, GW_CHILD)
    hCmb2% = GetWindow%(hCmb1%, GW_HWNDNEXT)
    
    'set focus to target module by selecting it in the
    'project listbox
    hWnd% = FindWindow%("project", 0&)
    r% = SetFocusAPI(hWnd%)
    hWnd% = GetWindow%(hWnd%, GW_CHILD)
    res& = SendMessageByString(hWnd%, LB_FINDSTRINGEXACT, -1, target$)
    res& = SendMessage(hWnd%, LB_SETCURSEL, Int(res&), 0&)
    r% = DoEvents()
    
    'make vb open the window
    SendKeys "~", True
    
    'jiggle the indices to get insertion point
    'set to end of general dec's section
    res& = SendMessage(hCmb2%, CB_GETCURSEL, 0, 0&)
    If res& = 0 Then
	SendKeys "^{down}", True
	res& = 1
    End If
    If res& > 0 Then
	For I% = 1 To Int(res&)
	    SendKeys "^{up}", True
	Next
    End If
    
    'now, paste it!
    SendKeys "^v", True
Exit Sub

autoerr:
MsgBox "Err: " & Err & nl & Error(Err), , "AUTOPASTE ERROR"
Exit Sub
End Sub

Sub PasteRobo (prefix$, lin$)
Dim target$, modtext$
Dim hBttn%
Dim hCode%, hWin%, hPane%, hCmb1%, hCmb2%, hOmod1%, hOmod2%, hProj%
Dim id%, lParam&
Dim txt$, s$, I%
Dim res&
Dim debugr%

On Error GoTo roboerr

txt$ = String(32, " ")

    target$ = UCase(dec.dest)
    '
    'set focus to target module by selecting it in the
    'project listbox
    hProj% = FindWindow%("project", 0&)
    '
    'get the listbox handle (error checking loop omitted, see GetListHandle)
    hWin% = GetWindow%(hProj%, GW_CHILD)
    '
    'select our target in the list
    res& = SendMessageByString(hWin%, LB_FINDSTRINGEXACT, -1, target$)
    res& = SendMessage(hWin%, LB_SETCURSEL, Int(res&), 0&)
    r% = SetFocusAPI(hWin%)
    r% = DoEvents()
    '
    'make vb open the code window
    SendKeys "{F7}", True

    r% = DoEvents()
    '
    'get handle to code window
    hCode% = FindWindow%("OEBDebug", target$)
    'get handle to the textboxes and pane
    hWin% = GetWindow%(hCode%, GW_CHILD)
    's$ = Left$(txt$, GetClassName(hWin%, txt$, Len(txt$)))
    hOmod1% = hWin%
    hWin% = GetWindow%(hWin%, GW_HWNDNEXT)
    's$ = Left$(txt$, GetClassName(hWin%, txt$, Len(txt$)))
    hOmod2% = hWin%
    hWin% = GetWindow%(hWin%, GW_HWNDNEXT)
    's$ = Left$(txt$, GetClassName(hWin%, txt$, Len(txt$)))
    hPane% = hWin%
    'get handle to comboboxes
    hCmb1% = GetWindow%(hPane%, GW_CHILD)
    hCmb2% = GetWindow%(hCmb1%, GW_HWNDNEXT)
    '
    'if you only allow pasting to global modules, this step is unnecessary:
    'set focus to combo1
    'r% = SetFocusAPI(hCode%)
    'r% = DoEvents()
    'SendKeys "^{F2}"
    'drop the menu down
    'r = DoEvents()
    'SendKeys "%{DOWN}", True
    'set it to '(general)'
    'res& = SendMessage(hCmb2%, CB_GETCOUNT, 0, 0&): 'Debug.Print "c1index" & res&
    'move up the list
    'For i% = 1 To Int(res&) + 1: SendKeys "{up}", True: Next
    'SendKeys "~", True
    'r = DoEvents()
    '
    'set focus to combo2
    res& = SendMessage(hCmb2%, CB_GETCOUNT, 0, 0&)
    r% = SetFocusAPI(hCode%)
    r% = DoEvents()
    'for new modules
    SendKeys "{HOME}"
    'for all other cases
    SendKeys "^{F2}"
    SendKeys "{TAB}"
    SendKeys "%{DOWN}", True
    'jiggle to make sure insertion point is reset
    SendKeys "{DOWN}"
    For I% = 1 To Int(res&) + 1: SendKeys "{up}", True: Next
    SendKeys "~", True
    r = DoEvents()

    '
'cursor is now in text area at start of text1
    'now select all the text in the window.
    'This operation is the cause of the pause.
    'This method is crude, but I cannot find any means of
    'determining how much text is in this window!
    'I set this to 1000 at first but it produces a huge
    'lag in response time. 300 works for me.
    r = DoEvents()
    For I% = 1 To 300
    SendKeys "+{DOWN}"
    Next

    r = DoEvents()
    '
    Clipboard.Clear
    SendKeys "^c"
    r = DoEvents()
    modtext$ = Clipboard.GetText()
    AddDeclaration modtext$, prefix$, lin$
    
    'confirm
    debugr% = MsgBox("Modify general declarations section?", 35)'33
    If debugr% = 2 Then 'cancel
	'deselect the text
	SendKeys "{ESC}"
	Exit Sub
    'debug: the dialog contains a 'no' choice so you can branch
    'here and see the modifications without pasting
    ElseIf debugr% = 7 Then 'no
	preview.Text1 = modtext$
	preview.Show
    Else
	Clipboard.SetText modtext$
    '
    r = DoEvents()
    r = DoEvents()
    '
    r% = SetFocusAPI(hOmod1%)
    '
    r = DoEvents()
    r = DoEvents()

    SendKeys "^v"
    End If
    '
Exit Sub

roboerr:
MsgBox "Err: " & Err & nl & Error(Err), , "ROBOPASTE ERROR"
Exit Sub
End Sub

